#!/bin/sh
#CopyMove  -*- TCL -*- Created: ramsan Feb-1997, Modified: ramsan Feb-1997

#----------------------CopyMove ALONE---------------------------
# the next line restarts using wish \
	exec wish4.2 "$0" "$@"
	
	set CopyMoveRunningAlone 0
# catch {
#     if {$argv0 == [info script] } {
#         set CopyMoveRunningAlone 1
#         set tcl_interactive 0
#         set tk_strictMotif 1
    
#         if { [catch { set GIDDEFAULT $env(GIDDEFAULT)}]!=1 } {
#             set GIDDEFAULTTCL $GIDDEFAULT
#             catch { set GIDDEFAULTTCL $env(GIDDEFAULTTCL) }
#             set auto_path "$GIDDEFAULTTCL"
#             source $GIDDEFAULTTCL/init.tcl
#             source $GIDDEFAULTTCL/tk.tcl
#         }
#         wm withdraw .
#     }
# }

#  LOOK AT THE END OF THE FILE !!!
#-------------------------------------------------------------------
		    
		    
proc ChangeTransfInCopy  { } {
    global CopyMoveInfo GidPriv

    set f $CopyMoveInfo(canvas).frame

    if { $CopyMoveInfo(Transformation) == "Sweep" && $CopyMoveInfo(EntitiesType) == "AllTypes" } {
	if { [catch { set whatuse [GiD_Info Project ViewMode] }] } {
	    set whatuse GEOMETRYUSE
	}
	if { $whatuse == "GEOMETRYUSE" } {                                   
	    #::GidUtils::SetWarnLine [_ "Sweep cannot be used with all types selection"]
	    set win [winfo toplevel $f].err
	    tk_dialogRAM $win [_ "Error"] [_ "Sweep cannot be used with all types selection"] error 0 [_ "OK"]             
	    after idle [list set CopyMoveInfo(Transformation) $CopyMoveInfo(Transformation_old)]
	    return
	}
    }

    if { $CopyMoveInfo(Transformation) == "Offset" && 
    $CopyMoveInfo(EntitiesType) != "Elements" && 
    $CopyMoveInfo(EntitiesType) != "Lines" && 
    $CopyMoveInfo(EntitiesType) != "Surfaces" } {        
	set win [winfo toplevel $f].err
	tk_dialogRAM $win [_ "Error"] \
		[_ "Offset can only be used for lines, surfaces or mesh elements"] \
		error 0 [_ "OK"]   
	after idle [list set CopyMoveInfo(Transformation) $CopyMoveInfo(Transformation_old)]
	return
    }
    foreach i [winfo children $f] {
	destroy $i
    }
    for {set i 1} {$i <= 6} {incr i} {
	if { ![info exists CopyMoveInfo(Num,$i)] } {
	    set CopyMoveInfo(Num,$i) ""
	}
	foreach axe "x y z" {
	    if { ![info exists CopyMoveInfo($axe,$i)] } {
		set CopyMoveInfo($axe,$i) 0.0
	    }
	}
    }
    if { $CopyMoveInfo(what) == "Copy" } {     
	switch $CopyMoveInfo(Transformation) \
		Translation { CopyTrans_ui $f } \
		Rotation { CopyRot_ui $f } \
		Mirror { CopyMirror_ui $f } \
		Scale { CopyScale_ui $f } \
		Offset { CopyOffset_ui $f } \
		Sweep { CopySweep_ui $f } \
		Align { CopyAlign_ui $f }
    } else {
	switch $CopyMoveInfo(Transformation) \
		Translation { CopyTrans_ui $f } \
		Rotation { CopyRot_ui $f } \
		Mirror { CopyMirror_ui $f } \
		Scale { CopyScale_ui $f } \
		Offset { CopyOffset_ui $f } \
		Align { CopyAlign_ui $f }
    }
    
    update idletasks
    $CopyMoveInfo(canvas) configure -scrollregion "0 0 \
	    [winfo width $f] \
	    [winfo height $f]"
    
    
    foreach i [winfo children $f] {
	bind $i <Tab> {+focus [tk_focusNext %W] ; EnteringFocusInCopy \
		[tk_focusNext %W] ; break}
	bind $i <Shift-Tab> {+focus [tk_focusPrev %W] ; \
		EnteringFocusInCopy [tk_focusPrev %W] ; break}
    }
    SetDisabledInCopy
    set CopyMoveInfo(Transformation_old) $CopyMoveInfo(Transformation)
}

proc EnteringFocusInCopy { w } {
    global CopyMoveInfo
    set c $CopyMoveInfo(canvas)
    
    set sr [$c cget -scrollregion]
    
    set val [expr double([winfo y $w])/[lindex $sr 3]-0.1]
    if { [expr abs([lindex [$c yview] 0] - $val)] > 0.05 } {
	$c yview moveto $val
    }
    catch { 
	$w sel from 0
	$w sel to end
    }
    
}

proc SetFocusTo { varname } {
    global CopyMoveInfo
    foreach i [winfo children $CopyMoveInfo(canvas).frame] {
	catch {
	    if { [$i cget -textvariable] == $varname } {
		focus $i
		EnteringFocusInCopy $i
		break
	    }
	}
    }
}

proc SetDisabledInCopy {} {
    global CopyMoveInfo GidPriv
    
    set w $CopyMoveInfo(mainframe)

    if { [catch { set whatuse [GiD_Info Project ViewMode] }] } {
	set whatuse GEOMETRYUSE
    }

    if { ( $whatuse != "GEOMETRYUSE") && ( $whatuse != "MESHUSE") } {
	$w.mcopy configure -state normal
	$w.mcopy configure -fg black
	
	$w.doextrude configure -state normal
	return
    }

    if { $CopyMoveInfo(Transformation) == "Offset" && \
		 $CopyMoveInfo(EntitiesType) != "Elements" && \
	 $CopyMoveInfo(EntitiesType) != "Lines" && \
		 $CopyMoveInfo(EntitiesType) != "Surfaces" } {
	set CopyMoveInfo(EntitiesType) $CopyMoveInfo(EntitiesType_old)
	set win [winfo toplevel $w].err
	tk_dialogRAM $win [_ "error"] \
	    [_ "Offset can only be used for lines, surfaces or mesh elements"] \
	    error 0 [_ "OK"]
	return
    }


    $w.checkbutton#1 configure -state normal        
    $w.mcopy configure -state normal
    $w.createcontact configure -state normal
    .wcopymove.select configure -command "AcceptInCopy .wcopymove"


    if { $CopyMoveInfo(what) == "Move" } {
	$w.doextrude configure -state disabled
	$w.createcontact configure -state disabled
	set GidPriv(CopyMoveMCopies) 1
	$w.mcopy configure -state disabled
	$w.mcopy configure -fg grey60
    } else {
	if { $CopyMoveInfo(EntitiesType) == "Points" || 
	$CopyMoveInfo(EntitiesType) == "Lines" || 
	$CopyMoveInfo(EntitiesType) == "Surfaces" || 
	$CopyMoveInfo(EntitiesType) == "Nodes" || 
	$CopyMoveInfo(EntitiesType) == "Elements" } {
	    $w.doextrude configure -state normal
	} else { 
	    $w.doextrude configure -state disabled 
	    set GidPriv(CopyMoveDoExtrude) No
	}

	if { $CopyMoveInfo(EntitiesType) == "Surfaces" } {
	    if { $CopyMoveInfo(Transformation) != "Sweep" } { 
		$w.createcontact configure -state normal
	    }
	} else { 
	    $w.createcontact configure -state disabled 
	    set GidPriv(CopyMoveCreateContacts) 0
	}
	if { $CopyMoveInfo(Transformation) == "Mirror" } {
	    set GidPriv(CopyMoveMCopies) 1
	    $w.mcopy configure -state disabled
	    $w.mcopy configure -fg grey60
	}
	if { $CopyMoveInfo(Transformation) == "Align" } {
	    set GidPriv(CopyMoveMCopies) 1
	    $w.mcopy configure -state disabled
	    $w.mcopy configure -fg grey60
	    $w.createcontact configure -state disabled 
	    set GidPriv(CopyMoveCreateContacts) 0
	}
    }
    set CopyMoveInfo(EntitiesType_old) $CopyMoveInfo(EntitiesType)   
}

proc EnterNumInCopy { num } {
    global CopyMoveInfo
    set inum $CopyMoveInfo(Num,$num)
    set w [winfo parent $CopyMoveInfo(mainframe)].err
    if { [regexp {^[ \t]*$} $inum] } { return void}

    if { ![regexp {^[ \t]*[0-9]+[ \t]*$} $inum] } {
	tk_dialogRAM $w [_ "error"] [_ "Number not valid"] error 0 [_ "OK"]
	SetFocusTo CopyMoveInfo(Num,$num)
	set CopyMoveInfo(Num,$num) ""
	return error
    }
    if { [regexp {^[ \t]*0+[ \t]*$} $inum] } {
	tk_dialogRAM $w [_ "error"] [_ "Number 0 not valid"] error 0 [_ "OK"]
	SetFocusTo CopyMoveInfo(Num,$num)
	set CopyMoveInfo(Num,$num) ""
	return error
    }
    set res [.central.s info Coordinates $inum]

    if { $res == "" } {
	tk_dialogRAM $w [_ "error"] [_ "Point number %d doesn't exist" $inum] error 0 [_ "OK"]
	SetFocusTo CopyMoveInfo(Num,$num)
	set CopyMoveInfo(Num,$num) ""
	return error
    }

    set res [lindex $res 0]
    set CopyMoveInfo(x,$num) [lindex $res 0]
    set CopyMoveInfo(y,$num) [lindex $res 1]
    set CopyMoveInfo(z,$num) [lindex $res 2]

    UpdateCopyMoveEntrySizes
}


proc UpdateCopyMoveEntrySizes {  } {
    global CopyMoveInfo
    set w $CopyMoveInfo(canvas).frame
    set coordw 10
    set idw 8
    set numentries ""
    set coordentries ""
    foreach i [winfo children $w] {
	if { [winfo class $i] == "Entry" } {
	    set varname [$i cget -textvariable]
	    if { [string match {CopyMoveInfo(Num,[1-6])} $varname ] } {
		lappend numentries $i
	    } elseif { [string match {CopyMoveInfo([xyz],[1-6])} $varname ] } {
		lappend coordentries $i
	    }
	} elseif { [winfo class $i] == "Labelframe" } {
	    foreach ii [winfo children $i] {
		if { [winfo class $ii] == "Entry" } {
		    set varname [$ii cget -textvariable]
		    if { [string match {CopyMoveInfo(Num,[1-6])} $varname ] } {
		        lappend numentries $ii
		    } elseif { [string match {CopyMoveInfo([xyz],[1-6])} $varname ] } {
		        lappend coordentries $ii
		    }
		}
	    }
	}
    }
    if { $numentries != "" } {
	eval SetWidgetsWidthFromTextWithMinimumSize $idw $numentries
    }
    if { $coordentries != "" } {
	eval SetWidgetsWidthFromTextWithMinimumSize $coordw $coordentries
    }
}

proc PickPointInMove { num } {
    global CopyMoveInfo    
    if { $num == 1 } {
	set msg [_ "Enter first point (ESC to leave)"]
    } elseif { $num == 2 } {
	set msg [_ "Enter second point (ESC to leave)"]
    } elseif { $num == 3 } {
	set msg [_ "Enter third point (ESC to leave)"]
    } else {
	set msg [_ "Enter point (ESC to leave)"]
    }
    set p1 [::GidUtils::GetCoordinates $msg]
    if { $p1 != "" } {
	if { $::GidPriv(selcoord,id) > 0 } {
	    set CopyMoveInfo(Num,$num) $::GidPriv(selcoord,id)
	} else {
	    set CopyMoveInfo(Num,$num) ""
	}
	set CopyMoveInfo(x,$num) [lindex $p1 0]
	set CopyMoveInfo(y,$num) [lindex $p1 1]
	set CopyMoveInfo(z,$num) [lindex $p1 2]

	UpdateCopyMoveEntrySizes
    } else {
	GidUtils::SetWarnLine [_ "Leaving"]
    }
}

proc AcceptInCopy { w } {
    global CopyMoveInfo GidPriv
    
    for {set i 1} {$i <= 6} {incr i} {
	if { $CopyMoveInfo(Transformation) == "Translation" } {
	    if { $i == 3 } break
	} elseif { $CopyMoveInfo(Transformation) == "Rotation" } {
	    if { $i == 3 || ( $i == 2 && [lindex $CopyMoveInfo(TwoDim) 0] == 1 ) } break
	} elseif { $CopyMoveInfo(Transformation) == "Mirror" } {
	    if { $i == 4 || ( $i == 3 && [lindex $CopyMoveInfo(TwoDim) 0] == 1 ) } break  
	} elseif { $CopyMoveInfo(Transformation) == "Scale" } {
	    if { $i == 3 } break  
	} elseif { $CopyMoveInfo(Transformation) == "Offset" } { 
	    break
	} elseif { $CopyMoveInfo(Transformation) == "Sweep" } { 
	    break
	} elseif { $CopyMoveInfo(Transformation) == "Align" } {
	    if { $i==7 || ( $i == 5 && [lindex $CopyMoveInfo(TwoDim) 0] == 1 ) } break  
	}

	if { $i == 2 && $CopyMoveInfo(Transformation) == "Scale" } {
	    set ret void
	} else {
	    set ret [EnterNumInCopy $i]
	}
	if { $ret == "error" } { return }
	if { $ret == "void" } {
	    set Number($i) ""
	    foreach axe "x y z" {
		if { ![string is double $CopyMoveInfo($axe,$i)] } {
		    tk_dialogRAM $w.err [_ "error"] [_ "Number not valid"] error 0 [_ "OK"]
		    SetFocusTo CopyMoveInfo($axe,$i)
		    return
		}
		append Number($i) [string trim $CopyMoveInfo($axe,$i)]
		if { $axe != "z" } { append Number($i) , }
	    }
	} else { catch { unset Number($i) } }
    }

    if { ![string is integer $GidPriv(CopyMoveMCopies)] } {
	tk_dialogRAM $w.err [_ "error"] [_ "Wrong number of copies"] \
	    error 0 [_ "OK"]
	return
    }
    if { $CopyMoveInfo(Transformation) == "Rotation" && ![string is double $CopyMoveInfo(Degree)] } {
	tk_dialogRAM $w.err [_ "error"] [_ "Angle not valid"] \
		error 0 [_ "OK"]
	SetFocusTo CopyMoveInfo(Degree)
	return
    } elseif { $CopyMoveInfo(Transformation) == "Offset" && ![string is double $CopyMoveInfo(OffsetFactor)] } {
	tk_dialogRAM $w.err [_ "error"] [_ "Offset factor not valid"] \
		error 0 [_ "OK"]
	SetFocusTo CopyMoveInfo(OffsetFactor)
	return
    } elseif { $CopyMoveInfo(Transformation) == "Sweep" } {
	set msgerr ""
	if { $CopyMoveInfo(path) == "" } {
	    set msgerr [_ "No path line entered"]   
	    tk_dialogRAM $w.err [_ "error"] $msgerr error 0 [_ "OK"]
	    return
	}
	if { $CopyMoveInfo(EndScale) == "" } {
	    set CopyMoveInfo(EndScale) 1.0
	} else {
	    if { $CopyMoveInfo(EndScale) <= 0 } {
		tk_dialogRAM $w.err [_ "error"] [_ "Sweep end scale not valid, must be greater than zero"] \
		        error 0 [_ "OK"]
		return
	    }
	}
	if { $CopyMoveInfo(TwistAngle) == "" } {
	    set CopyMoveInfo(TwistAnge) 0.0
	}
	if { ($CopyMoveInfo(x,1) == "") || ($CopyMoveInfo(z,1) == "") \
	    || ($CopyMoveInfo(y,1) == "") } {
	    if { $CopyMoveInfo(EnabledCurveTwist) == 1 } {
		set msgerr [_ "Bad direction in twist mode."] 
		tk_dialogRAM $w.err [_ "error"] $msgerr error 0 [_ "OK"]
		return
	    }
	}
	if { $CopyMoveInfo(EntitiesType) == "Points" } {
	    if { $GidPriv(CopyMoveDoExtrude) == "Surfaces" || \
		$GidPriv(CopyMoveDoExtrude) == "Volumes" } {
	       set msgerr [_ "Sorry, cannot extrude to %s." $GidPriv(CopyMoveDoExtrude)]
		tk_dialogRAM $w.err [_ "error"] $msgerr error 0 [_ "OK"]
		return
	    }
	} elseif { $CopyMoveInfo(EntitiesType) == "Lines" } {
	    if { $GidPriv(CopyMoveDoExtrude) == "Volumes" } {
		set msgerr [_ "Sorry, cannot extrude to %s." $GidPriv(CopyMoveDoExtrude)]
		tk_dialogRAM $w.err [_ "error"] $msgerr error 0 [_ "OK"]
		return
	    }
	}
    }

    if { [catch { set whatuse [GiD_Info Project ViewMode] }] } {
	set whatuse GEOMETRYUSE
    }

    set res ".central.s process escape escape escape escape utilities"
    
    if { ( $whatuse == "GEOMETRYUSE") || ( $whatuse == "MESHUSE") } {
	lappend res $CopyMoveInfo(what)
	lappend res $CopyMoveInfo(EntitiesType)
	if { $GidPriv(DuplicateEntities) != 0 } {
	    lappend res Duplicate
	}
	if { $CopyMoveInfo(what) == "Copy" } {
	    if { $GidPriv(CopyMoveDoExtrude) == "Lines" } {
		lappend res DoExtrude Lines
	    } elseif { $GidPriv(CopyMoveDoExtrude) == "Surfaces" } {
		lappend res DoExtrude Surfaces
	    } elseif { $GidPriv(CopyMoveDoExtrude) == "Volumes" } {
		lappend res DoExtrude Volumes
	    }
	    if { $GidPriv(CopyMoveCreateContacts) == 1 } {
		lappend res Contacts
	    }
	}
	if { $GidPriv(CopyMoveMaintainLayers)  == 1 } {
	    lappend res MaintainLayers
	}
	if { $GidPriv(CopyMoveMCopies) != 1 } {
	    lappend res MCopy
	    lappend res $GidPriv(CopyMoveMCopies)
	}
    } else {
	# Postprocess
	lappend res transformation 
	if { $GidPriv(CopyMoveMCopies) != 1 } {
	    lappend res RepeatTransf
	    lappend res $GidPriv(CopyMoveMCopies)
	}
	#lappend res transformation
	if { $GidPriv(PostDuplicateEntities)} {
	    if { $CopyMoveInfo(PostDuplicateWhat) == "Create volume/surface" } {
		lappend res create yes
	    } else {
		# $GidPriv(PostDuplicateWhat) == "Extrude sets"
		lappend res create extrude
	    }
	}
    }

    lappend res $CopyMoveInfo(Transformation)


    for {set i 1} {$i <= 6} {incr i} {
	if { $CopyMoveInfo(Transformation) == "Translation" } {
	    if { ![info exists Number($i)] } {
		lappend res FJoin $CopyMoveInfo(Num,$i)
	    } else {
		lappend res FNoJoin $Number($i)
	    }
	    if { $i == 2 } break
	} elseif { $CopyMoveInfo(Transformation) == "Rotation" } {
	    if { $i == 2 && [lindex $CopyMoveInfo(TwoDim) 0] == 1 } {
		lappend res TwoDim
		lappend res $CopyMoveInfo(Degree)
		break
	    } elseif { ![info exists Number($i)] } {
		lappend res FJoin $CopyMoveInfo(Num,$i)
	    } else {
		lappend res FNoJoin $Number($i)
	    }
	    if { $i == 2 } { 
		lappend res $CopyMoveInfo(Degree)
		break
	    }
	} elseif { $CopyMoveInfo(Transformation) == "Mirror" } {
	    if { $i == 3 && [lindex $CopyMoveInfo(TwoDim) 0] == 1 } {
		lappend res TwoDim
		break
	    } elseif { ![info exists Number($i)] } {
		lappend res FJoin $CopyMoveInfo(Num,$i)
	    } else {
		lappend res FNoJoin $Number($i)
	    }
	    if { $i == 3 } break
	} elseif { $CopyMoveInfo(Transformation) == "Scale" } {
	    if { ![info exists Number($i)] } {
		lappend res FJoin $CopyMoveInfo(Num,$i)
	    } else {
		lappend res FNoJoin $Number($i)
	    }
	    foreach axe {x y z} {
		set CopyMoveInfo($axe,scale) [string trim $CopyMoveInfo($axe,scale)]
		if { ![string is double $CopyMoveInfo($axe,scale)] } {
		    tk_dialogRAM $w.err [_ "error"] [_ "Number not valid"] error 0 [_ "OK"]
		    SetFocusTo CopyMoveInfo($axe,scale)
		    return
		}
	    }
	    lappend res FNoJoin "$CopyMoveInfo(x,scale),$CopyMoveInfo(y,scale),$CopyMoveInfo(z,scale)"
	    break
	} elseif { $CopyMoveInfo(Transformation) == "Offset" } { 
	    lappend res $CopyMoveInfo(OffsetFactor)
	    if { $i == 1 } break
	} elseif { $CopyMoveInfo(Transformation) == "Sweep" } { 
	    lappend res $CopyMoveInfo(path)
	    lappend res $CopyMoveInfo(TwistAngle)
	    lappend res $CopyMoveInfo(TwistMode)
	    if { $GidPriv(CopyMoveDoExtrude) == "No" } {
		if { $CopyMoveInfo(EnabledCurveTwist) == 0 } {
		    lappend res 2
		} else {
		    lappend res 3
		}
	    } else {
		if { $CopyMoveInfo(EnabledCurveTwist) == 0 } {
		    lappend res 0
		} else {
		    lappend res 1
		}
	    }
	    lappend res $CopyMoveInfo(x,1) $CopyMoveInfo(y,1) $CopyMoveInfo(z,1)
	    lappend res $CopyMoveInfo(EndScale)
	    if { $i == 1 } break
	} elseif { $CopyMoveInfo(Transformation) == "Align" } {            
	    if { ($i == 5 && [lindex $CopyMoveInfo(TwoDim) 0] == 1) } {
		lappend res TwoDim
		break
	    } elseif { ![info exists Number($i)] } {
		lappend res FJoin $CopyMoveInfo(Num,$i)
	    } else {
		lappend res FNoJoin $Number($i)
	    }
	    if { $i == 6 } break  
	}
    }

    # That's for Windows
    #focus .central.s
    gidmakecurrent
    eval $res

    if { ( $whatuse == "GEOMETRYUSE") || ( $whatuse == "MESHUSE") } {
	set SmallWinSelecting [.central.s info variable SmallWinSelecting]
	FinishButton $w $w.buts [_ "Press 'Finish' to end selection"] \
		SetDisabledInCopy disableall $SmallWinSelecting
    }

}

source $GIDDEFAULTTCL/CopyMain.ui.tcl
source $GIDDEFAULTTCL/CopyTrans.ui.tcl
source $GIDDEFAULTTCL/CopyRot.ui.tcl
source $GIDDEFAULTTCL/CopyScale.ui.tcl
source $GIDDEFAULTTCL/CopyMirror.ui.tcl
source $GIDDEFAULTTCL/CopyOffset.ui.tcl
source $GIDDEFAULTTCL/CopySweep.ui.tcl
source $GIDDEFAULTTCL/CopyAlign.ui.tcl


proc PostTransformations { { w .wtransformation } } {
    if { [catch { set whatuse [GiD_Info Project ViewMode] }] } {
	set whatuse GEOMETRYUSE
    }
    if { ( $whatuse != "GEOMETRYUSE") && ( $whatuse != "MESHUSE") } {
	CopyMove "Copy" $w
    }
}

proc PostChangedShowTransf { name1 name2 op} {
    global CopyMoveInfo GidPriv
    
    if { $GidPriv(CopyMoveDoExtrude) == "Show" } {
	.central.s process utilities transformation usetransfs Yes
    } else {
	.central.s process utilities transformation usetransfs No
    }
}

proc PostChangedDuplicate { name1 name2 op} {
    global CopyMoveInfo GidPriv

    if { $GidPriv(PostDuplicateEntities) } {
	#$CopyMoveInfo(mainframe).doextrudel configure -foreground grey60
	#$CopyMoveInfo(mainframe).doextrude configure -state disabled
	$CopyMoveInfo(mainframe).fopt.bdellast configure -state disabled
	$CopyMoveInfo(mainframe).fopt.bclearall configure -state disabled

	ComboBoxRAM $CopyMoveInfo(mainframe).doextrude CopyMoveInfo(PostDuplicateWhat) \
		[list [_ "Create volume/surface"] [_ "Extrude surface"]] \
		{"Create volume/surface" "Extrude surface"}
	
	grid $CopyMoveInfo(mainframe).doextrude -in $CopyMoveInfo(mainframe).fopt -row 0 -column 0 \
		-sticky we -pady 1 -padx 0 -ipady 1 -columnspan 2
	set CopyMoveInfo(PostDuplicateWhat) "Create volume/surface"

    } else {
	$CopyMoveInfo(mainframe).doextrudel configure -foreground black
	#$CopyMoveInfo(mainframe).doextrude configure -state normal
	$CopyMoveInfo(mainframe).fopt.bdellast configure -state normal
	$CopyMoveInfo(mainframe).fopt.bclearall configure -state normal

	ComboBoxRAM $CopyMoveInfo(mainframe).doextrude GidPriv(CopyMoveDoExtrude) \
		[list [_ "Show"] [_ "Hide"]] \
		{Show Hide}
	
	grid $CopyMoveInfo(mainframe).doextrude -in $CopyMoveInfo(mainframe).fopt -row 0 -column 0 \
		-sticky e -pady 1 -padx 0 -ipady 1
	set CopyMoveInfo(PostDuplicateWhat) "Show"
    }
}


proc UpdateCopyMove { { w .wcopymove } } {
    if {![winfo exists $w]} return
    
    set what [wm title $w]
    if { $what == [_ "Copy"] } {
	set what "Copy"
    } elseif { $what == [_ "Move"] } {
	set what "Move"
    }
    CopyMove $what
}

proc CopyMove { what { w .wcopymove } } {
    global CopyMoveInfo GidPriv    

    if { [catch { set whatuse [GiD_Info Project ViewMode] }] } {
	set whatuse GEOMETRYUSE
    }

    if { $what == [_ "Transform"]} { 
	set whatuse POSTUSE
    }

    if { ( $whatuse == "GEOMETRYUSE") || ( $whatuse == "MESHUSE") } {
	if { ![info exists GidPriv(DuplicateEntities)] } {
	    set GidPriv(DuplicateEntities) 0
	}
	if { ![info exists GidPriv(CopyMoveDoExtrude)] } {
	    set GidPriv(CopyMoveDoExtrude) No
	}
	if { ![info exists GidPriv(CopyMoveMaintainLayers)] } {
	    set GidPriv(CopyMoveMaintainLayers) 1
	}
    } else {
	if { ![info exists GidPriv(CopyMoveDoExtrude)] } {
	    set GidPriv(CopyMoveDoExtrude) Show
	}
	if { ![info exists GidPriv(PostDuplicateEntities)] } {
	    set GidPriv(PostDuplicateEntities) 0
	}
    }
    if { ![info exists GidPriv(CopyMoveCreateContacts)] } {
	set GidPriv(CopyMoveCreateContacts) 0
    }
    if { ![info exists GidPriv(CopyMoveMCopies)] } {
	set GidPriv(CopyMoveMCopies) 1
    }
    if { ![info exists GidPriv(CopyMoveSameFactors)] } {
	set GidPriv(CopyMoveSameFactors) 1
    }

    if { ( $whatuse == "GEOMETRYUSE") || ( $whatuse == "MESHUSE") } {
	if { $what == "Copy" } {
	    set title [_ "Copy"]
	} elseif { $what == "Move" } {
	    set title [_ "Move"]
	} else { 
	    set title [_ $what]
	}
	InitWindow $w $title CopyMoveWindowGeom [list CopyMove $what]
	if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
    } else {
	if { $w == ".wcopymove"} {
	    set w .wtransformation
	}
	InitWindow $w [_ "Transformations"] PostTransformWindowGeom [list CopyMove Transform]
	if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
	#PostTransformations
	trace remove variable GidPriv(PostDuplicateEntities) write PostChangedDuplicate
    }
    
    #set CopyMoveInfo after InitWindow, else if the window exists CopyMoveInfo are unset
    catch { array unset CopyMoveInfo }

    set CopyMoveInfo(what) $what
    set CopyMoveInfo(x,scale) 1.0
    set CopyMoveInfo(y,scale) 1.0
    set CopyMoveInfo(z,scale) 1.0
 
    set CopyMoveInfo(Transformation) "Translation"
    set CopyMoveInfo(Transformation_old) $CopyMoveInfo(Transformation)
    if { $whatuse == "MESHUSE" } {
	set CopyMoveInfo(EntitiesType) Nodes
    } else {
	set CopyMoveInfo(EntitiesType) Points
    }
    set CopyMoveInfo(EntitiesType_old) $CopyMoveInfo(EntitiesType)

    frame $w.f -relief ridge -bd 2
    set CopyMoveInfo(canvas) [CopyMain_ui $w.f] ;#create window contents
    set CopyMoveInfo(mainframe) $w.f


    frame $w.buts -bg [CCColorActivo [$w cget -background]]

    if { ( $whatuse == "GEOMETRYUSE") || ( $whatuse == "MESHUSE") } {
	set textselect [_ "Select"]
	set textcancel [_ "Cancel"]
    } else {
	set textselect [_ "Apply"]
	set textcancel [_ "Close"]
    }
    button $w.select -text $textselect -command "AcceptInCopy $w" -bd 1
    button $w.cancel -text $textcancel -command "destroy $w" -bd 1
    SetWidgetsWidthFromText $w.select $w.cancel

    grid $w.f -ipadx 2 -pady 2 -sticky nswe
    grid $w.buts -sticky ew
    grid $w.select $w.cancel -in $w.buts -pady 3 -ipady 0 -padx 0 -ipadx 0 -padx 5
    grid columnconfigure $w 0 -weight 1
    #grid columnconfigure $w 1 -weight 1
    grid rowconfigure $w 0 -weight 1

    frame $CopyMoveInfo(canvas).frame -bd 0
    $CopyMoveInfo(canvas) create window 0 0 -anchor nw -window $CopyMoveInfo(canvas).frame

    if { ( $whatuse == "GEOMETRYUSE") || ( $whatuse == "MESHUSE") } {
    } else {
	trace add variable GidPriv(CopyMoveDoExtrude) write PostChangedShowTransf
	trace add variable GidPriv(PostDuplicateEntities) write PostChangedDuplicate

	PostChangedDuplicate a b c
    }

    #set initial mode
    SetDisabledInCopy
    ChangeTransfInCopy

    bind $w <Escape> [list destroy $w]
    bind $w <Control-a> [bind .gid <Control-a>]
    bind $w <Destroy> [list +DestroyCopyMove %W $w] ;# + to add to previous script

    trace add variable CopyMoveInfo(Transformation) write "ChangeTransfInCopy ;#"
    trace add variable CopyMoveInfo(EntitiesType) write "SetDisabledInCopy ;#"
}

proc DestroyCopyMove { W w } {    
    if { $W != $w } return
    #reenter multiple times, one by toplevel child, only interest w
    global CopyMoveInfo GidPriv
    catch { array unset CopyMoveInfo } ;#remove also CopyMoveInfo traces
    trace remove variable GidPriv(CopyMoveDoExtrude) write PostChangedShowTransf
    trace remove variable GidPriv(PostDuplicateEntities) write PostChangedDuplicate
    
    trace remove variable GidPriv(CopyMoveDoExtrude) write PostChangedShowTransf
    trace remove variable GidPriv(PostDuplicateEntities) write PostChangedDuplicate
}


#----------------------CopyMove ALONE---------------------------
# if { $CopyMoveRunningAlone == 1 } {
#     CopyMove Copy
# } 
#-----------------------------------------------------------------
