proc CustomizeRender { {w .gid.customizerender} } {    
    global GIDDEFAULT GidPriv 
    global CustomizeRenderPriv 

    unset -nocomplain CustomizeRenderPriv

    InitWindow $w [_ "Customize Render"] CustomizeRenderWindowGeom CustomizeRender
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
  
    frame $w.frm1
    ComboBox $w.frm1.cb1 -editable 0 -textvariable CustomizeRenderPriv(CustomRenderCurrent) \
	    -values [GiD_Info customrenders]
    GidHelp $w.frm1.cb1 [_ "It set the current customized render mode"]
    button $w.frm1.b1 -image [GetImage check.gif] -command "NewCustomRender $w.frm1.cb1"
    GidHelp $w.frm1.b1 [_ "It creates a new customized render mode"]
    button $w.frm1.b2 -image [GetImage rename2.gif] -command "RenameCustomRender $w.frm1.cb1"
    GidHelp $w.frm1.b2 [_ "It changes the customized render name"]
    button $w.frm1.b3 -image [GetImage erase-cross.gif] -command "DeleteCustomRender $w.frm1.cb1"
    GidHelp $w.frm1.b3 [_ "It deletes the selected customized render mode."]

    frame $w.frm2
    label $w.frm2.l01 -text [_ "Show"] 
    label $w.frm2.l02 -text [_ "Color by"]
    label $w.frm2.l03 -text [_ "Size"]
    label $w.frm2.l04 -text [_ "Render"]

    label $w.frm2.l10 -image [GetImage "point16x16.gif"] -width 5
    label $w.frm2.l20 -image [GetImage "line16x16.gif"]
    label $w.frm2.l30 -image [GetImage "coonsurf16x16.gif"]
    label $w.frm2.l40 -image [GetImage "volume16x16.gif"]

    checkbutton $w.frm2.ck1 -variable CustomizeRenderPriv(Show,Point) -width 3        
    checkbutton $w.frm2.ck2 -variable CustomizeRenderPriv(Show,Line)        
    checkbutton $w.frm2.ck3 -variable CustomizeRenderPriv(Show,Surface)
    checkbutton $w.frm2.ck4 -variable CustomizeRenderPriv(Show,Volume)                

    ComboBox $w.frm2.cb1 -editable 0 -modifycmd "ModifyComboBoxCommand $w.frm2.cb1 Point" \
	    -values [list [_ "Layer"] [_ "EntityType"]]
    ComboBox $w.frm2.cb2 -editable 0 -modifycmd "ModifyComboBoxCommand $w.frm2.cb2 Line" \
	    -values [list [_ "Layer"] [_ "EntityType"] [_ "Black"]]
    ComboBox $w.frm2.cb3 -editable 0 -modifycmd "ModifyComboBoxCommand $w.frm2.cb3 Surface" \
	    -values [list [_ "Layer"] [_ "EntityType"]]
    ComboBox $w.frm2.cb4 -editable 0 -modifycmd "ModifyComboBoxCommand $w.frm2.cb4 Volume" \
	    -values [list [_ "Layer"] [_ "EntityType"]]

    trace add variable CustomizeRenderPriv(ColorBy,Point) write "SetComboBoxTextColorBy $w.frm2.cb1 Point ;#"
    trace add variable CustomizeRenderPriv(ColorBy,Line) write "SetComboBoxTextColorBy $w.frm2.cb2 Line ;#"
    trace add variable CustomizeRenderPriv(ColorBy,Surface) write "SetComboBoxTextColorBy $w.frm2.cb3 Surface ;#"
    trace add variable CustomizeRenderPriv(ColorBy,Volume) write "SetComboBoxTextColorBy $w.frm2.cb4 Volume ;#"
   
    #valid for OpenGL specification of point size and line width  -range "0.5 10 0.5"
    SpinBox $w.frm2.sb1 -editable 1 -textvariable CustomizeRenderPriv(Size,Point) \
	    -values "1 2 3 4 5 6 7 8 9 10" -width 5
    SpinBox $w.frm2.sb2 -editable 1 -textvariable CustomizeRenderPriv(Size,Line)\
	    -values "1 2 3 4 5 6 7 8 9 10" -width 5
    SpinBox $w.frm2.sb3 -editable 1 -textvariable CustomizeRenderPriv(Size,Surface) \
	    -values "1 2 3 4 5 6 7 8 9 10" -width 5
    SpinBox $w.frm2.sb4 -editable 1 -textvariable CustomizeRenderPriv(Size,Volume) \
	    -values "1 2 3 4 5 6 7 8 9 10" -width 5

    frame $w.frm3
    checkbutton $w.frm3.ck1 -variable CustomizeRenderPriv(FillSurface) -text [_ "Fill Surfaces"]
    checkbutton $w.frm3.ck2 -variable CustomizeRenderPriv(Lighting) -text [_ "Lighting"]
    checkbutton $w.frm3.ck3 -variable CustomizeRenderPriv(Blend) -text [_ "Blend"]   
    
    
    set def_back [$w cget -background]
    frame $w.frmButtons -bg [CCColorActivo $def_back]
    button $w.frmButtons.btnApply -text [_ "Apply"] \
	    -command "SetTclValues" \
	    -underline 0 -width 6
    button $w.frmButtons.btnReset -text [_ "Reset"] \
	    -command "SetDefaultValues" \
	    -underline 0 -width 6
    button $w.frmButtons.btnclose -text [_ "Close"] \
	    -command "destroy $w" \
	    -underline 0 -width 6
    SetWidgetsWidthFromText $w.frmButtons.btnApply $w.frmButtons.btnReset $w.frmButtons.btnclose
    

    #empaquetamiento de los widgets
   
    grid $w.frm1.cb1 $w.frm1.b1 $w.frm1.b2 $w.frm1.b3 -sticky w
    grid configure $w.frm1.cb1 -sticky ew
    grid columnconf $w.frm1 "0" -weight 1 
    grid $w.frm1 -padx 5 -pady 5 -sticky ew

    grid      x     $w.frm2.l01 $w.frm2.l02 $w.frm2.l03 -sticky ew
    grid $w.frm2.l10 $w.frm2.ck1 $w.frm2.cb1 $w.frm2.sb1 -sticky ew
    grid $w.frm2.l20 $w.frm2.ck2 $w.frm2.cb2 $w.frm2.sb2 -sticky ew
    grid $w.frm2.l30 $w.frm2.ck3 $w.frm2.cb3 $w.frm2.sb3 -sticky ew
    grid $w.frm2.l40 $w.frm2.ck4 $w.frm2.cb4 $w.frm2.sb4 -sticky ew
    grid columnconf $w.frm2 "2" -weight 1   
    grid $w.frm2 -padx 5 -pady 5 -sticky ew
    
    grid $w.frm3.ck1 $w.frm3.ck2 $w.frm3.ck3 -sticky ew
    grid $w.frm3 -padx 5 -pady 5 -sticky ew

    grid $w.frmButtons -sticky ews -columnspan 7
    grid $w.frmButtons.btnApply $w.frmButtons.btnReset $w.frmButtons.btnclose -padx 5 -pady 6
    grid columnconf $w "0" -weight 1
    grid rowconfigure $w "1" -weight 1
    
    focus $w.frmButtons.btnApply
    
    bind $w <Alt-c> "tkButtonInvoke $w.frmButtons.btnclose"
    bind $w <Escape> "tkButtonInvoke $w.frmButtons.btnclose"
    bind $w <Return> "tkButtonInvoke $w.frmButtons.btnApply"
    # sign + is necessary because this binding is necessary for InitWindow
    bind $w <Destroy> [list +DestroyCustomizeRender %W $w] ;# + to add to previous script
    wm minsize $w 140 175

    
    SetGidValues

    set rendertype [GiD_Info Project RenderMode]
    if { $rendertype == "custom" } {
	set CustomizeRenderPriv(CustomRenderCurrent) [GiD_Info customrenders current]
    } else {
	set CustomizeRenderPriv(CustomRenderCurrent) ""
    }
    
    trace add variable CustomizeRenderPriv(CustomRenderCurrent) write "SetCustomRenderCurrent ;#"
    trace add variable CustomizeRenderPriv(Show,Point) write "UpdateState $w Point ;#"
    trace add variable CustomizeRenderPriv(Show,Line) write "UpdateState $w Line ;#"
    trace add variable CustomizeRenderPriv(Show,Surface) write "UpdateState $w Surface ;#"
    trace add variable CustomizeRenderPriv(Show,Volume) write "UpdateState $w Volume ;#"
}


proc DestroyCustomizeRender { W w } {
    if { $W != $w } return
    #avoid reenter multiple times, one by child
    global CustomizeRenderPriv
    trace remove variable CustomizeRenderPriv(ColorBy,Point) write "SetComboBoxTextColorBy $w.frm2.cb1 Point ;#"
    trace remove variable CustomizeRenderPriv(ColorBy,Line) write "SetComboBoxTextColorBy $w.frm2.cb2 Line ;#"
    trace remove variable CustomizeRenderPriv(ColorBy,Surface) write "SetComboBoxTextColorBy $w.frm2.cb3 Surface ;#"
    trace remove variable CustomizeRenderPriv(ColorBy,Volume) write "SetComboBoxTextColorBy $w.frm2.cb4 Volume ;#"

    trace remove variable CustomizeRenderPriv(CustomRenderCurrent) write "SetCustomRenderCurrent ;#"
    trace remove variable CustomizeRenderPriv(Show,Point) write "UpdateState $w Point ;#"
    trace remove variable CustomizeRenderPriv(Show,Line) write "UpdateState $w Line ;#"
    trace remove variable CustomizeRenderPriv(Show,Surface) write "UpdateState $w Surface ;#"
    trace remove variable CustomizeRenderPriv(Show,Volume) write "UpdateState $w Volume ;#"
    #if face is not necessary remove remove traces because unsettting the variable will be removed
    unset -nocomplain CustomizeRenderPriv
}

proc SetCustomRenderCurrent { } {
    global CustomizeRenderPriv
    if { $CustomizeRenderPriv(CustomRenderCurrent) == "" } return
    GiD_Process escape escape escape escape view render customized \
		changecustom $CustomizeRenderPriv(CustomRenderCurrent)
    GiD_Redraw
    SetGidValues
}

proc NewCustomRender { w } {
    global CustomizeRenderPriv

    set Ret [tk_dialogEntryRAM .gid.tempwinw [_ "New customized render mode"] \
		 [_ "Enter new render mode name"]  gidquestionhead any "" ]
    if { $Ret == "--CANCEL--" ||  $Ret == "" } { return  }

    set customrenders [GiD_Info customrenders]
    foreach i $customrenders {
	if { $i == $Ret } {
	    WarnWin [_ "Custom render '%s' already exists" $Ret ]  
	    return
	}
    }

    GiD_Process escape escape escape escape View Render Customized \
	    NewCustom $Ret
    
    $w configure -values [GiD_Info customrenders]

    set CustomizeRenderPriv(CustomRenderCurrent) $Ret
}

proc RenameCustomRender { w } {
    global CustomizeRenderPriv
    set oldname [$w cget -text]
    if { $oldname == "" } return
    set Ret [tk_dialogEntryRAM .gid.tempwinw [_ "Rename customized render"] \
		 [_ "Enter new name for rende mode"]  gidquestionhead any $oldname ]
    if { $Ret == "--CANCEL--" ||  $Ret == "" } { return  }
    
    if { $Ret == $oldname } return

    set customrenders [GiD_Info customrenders]
    foreach i $customrenders {
	if { $i == $Ret } {
	    WarnWin [_ "Custom render '%s' already exists" $Ret ]  
	    return
	}
    }

    GiD_Process escape escape escape escape View Render Customized \
	    RenameCustom $oldname $Ret
    $w configure -values [GiD_Info customrenders]
    set CustomizeRenderPriv(CustomRenderCurrent) $Ret
}

proc DeleteCustomRender { w } {
    global CustomizeRenderPriv
    if { $CustomizeRenderPriv(CustomRenderCurrent) == "" } return

    set retval [tk_dialogRAMFull .gid.tempwinw [_ "Delete customized render mode"] \
	    [_ "Are you sure to delete\n custom render '%s'?" $CustomizeRenderPriv(CustomRenderCurrent)] \
	     "" "" gidquestionhead 0 [_ "Yes"] [_ "No#C#I don't want to do that"]]
    if { $retval == 1 } { return }

    GiD_Process escape escape escape escape View Render Customized \
	    DeleteCustom $CustomizeRenderPriv(CustomRenderCurrent)

    set customrenders [GiD_Info customrenders]
    $w configure -values $customrenders
    
    set CustomizeRenderPriv(CustomRenderCurrent) [lindex $customrenders 0]
    if { $CustomizeRenderPriv(CustomRenderCurrent) == "" } {
	GiD_Redraw
    }
}

proc UpdateState { w EntityType } {
    global CustomizeRenderPriv
    if { $EntityType == "Point" } {
	if { $CustomizeRenderPriv(Show,Point) } {
	    $w.frm2.cb1 configure -state normal
	    $w.frm2.sb1 configure -state normal
	} else {
	    $w.frm2.cb1 configure -state disabled
	    $w.frm2.sb1 configure -state disabled
	}
    } elseif { $EntityType == "Line" } {
	if { $CustomizeRenderPriv(Show,Line) } {
	    $w.frm2.cb2 configure -state normal
	    $w.frm2.sb2 configure -state normal
	} else {
	    $w.frm2.cb2 configure -state disabled
	    $w.frm2.sb2 configure -state disabled
	}
    } elseif { $EntityType == "Surface" } {
	if { $CustomizeRenderPriv(Show,Surface) } {
	    $w.frm2.cb3 configure -state normal
	    $w.frm2.sb3 configure -state normal
	    $w.frm3.ck1 configure -state normal
	} else {
	    $w.frm2.cb3 configure -state disabled
	    $w.frm2.sb3 configure -state disabled
	    $w.frm3.ck1 configure -state disabled
	}
    } elseif { $EntityType == "Volume" } {
	if { $CustomizeRenderPriv(Show,Volume) } {
	    $w.frm2.cb4 configure -state normal
	    $w.frm2.sb4 configure -state normal
	} else {
	    $w.frm2.cb4 configure -state disabled
	    $w.frm2.sb4 configure -state disabled
	}
    }
}

proc ModifyComboBoxCommand { w entitytype } {
    global CustomizeRenderPriv 
    set CustomizeRenderPriv(ColorBy,$entitytype) [$w getvalue]
}

proc SetComboBoxTextColorBy { w entitytype } {
    global CustomizeRenderPriv
    if { $CustomizeRenderPriv(ColorBy,$entitytype) == "0" } {
	$w configure -text [_ "Layer"]
    } elseif { $CustomizeRenderPriv(ColorBy,$entitytype) == "1" } {
	$w configure -text [_ "EntityType"]
    } else {
	$w configure -text [_ "Black"]
    }
}

proc SetDefaultValues { } {
    global CustomizeRenderPriv 
    set CustomizeRenderPriv(Show,Point)        1
    set CustomizeRenderPriv(Show,Line) 1
    set CustomizeRenderPriv(Show,Surface) 1
    set CustomizeRenderPriv(Show,Volume) 1        
    #0 color by layer        
    #1 color by entity type
    set CustomizeRenderPriv(ColorBy,Point) 1
    set CustomizeRenderPriv(ColorBy,Line) 0
    set CustomizeRenderPriv(ColorBy,Surface) 1
    set CustomizeRenderPriv(ColorBy,Volume) 1

    set CustomizeRenderPriv(Size,Point) 3
    set CustomizeRenderPriv(Size,Line) 1
    set CustomizeRenderPriv(Size,Surface) 1
    set CustomizeRenderPriv(Size,Volume) 1

    set CustomizeRenderPriv(FillSurface) 0
    set CustomizeRenderPriv(Lighting) 0
    set CustomizeRenderPriv(Blend) 0
}

proc SetGidValues { } {
    global CustomizeRenderPriv 
    if { [GiD_Info customrenders current] == "" } return

    set CustomizeRenderPriv(Show,Point) [GiD_Info variables CustomRender(Show,Point)]
    set CustomizeRenderPriv(Show,Line) [GiD_Info variables CustomRender(Show,Line)]
    set CustomizeRenderPriv(Show,Surface) [GiD_Info variables CustomRender(Show,Surface)]
    set CustomizeRenderPriv(Show,Volume) [GiD_Info variables CustomRender(Show,Volume)]        
    #0 color by layer        
    #1 color by entity type
    set CustomizeRenderPriv(ColorBy,Point) [GiD_Info variables CustomRender(ColorBy,Point)]
    set CustomizeRenderPriv(ColorBy,Line) [GiD_Info variables CustomRender(ColorBy,Line)]
    set CustomizeRenderPriv(ColorBy,Surface) [GiD_Info variables CustomRender(ColorBy,Surface)]
    set CustomizeRenderPriv(ColorBy,Volume) [GiD_Info variables CustomRender(ColorBy,Volume)]
    
    set CustomizeRenderPriv(Size,Point) [expr int([GiD_Info variables CustomRender(Size,Point)])]
    set CustomizeRenderPriv(Size,Line) [expr int([GiD_Info variables CustomRender(Size,Line)])]
    set CustomizeRenderPriv(Size,Surface) [expr int([GiD_Info variables CustomRender(Size,Surface)])]
    set CustomizeRenderPriv(Size,Volume) [expr int([GiD_Info variables CustomRender(Size,Volume)])]
    
    set CustomizeRenderPriv(FillSurface) [GiD_Info variables CustomRender(FillSurface)]
    set CustomizeRenderPriv(Lighting) [GiD_Info variables CustomRender(Lighting)]
    set CustomizeRenderPriv(Blend) [GiD_Info variables CustomRender(Blend)]
}

proc SetTclValues { } {
    global CustomizeRenderPriv 
    if { [GiD_Info customrenders current] == "" } return
    ::GidUtils::DisableWarnLine
    GiD_Process escape escape escape escape utilities variables \
	CustomRender(Show,Point) $CustomizeRenderPriv(Show,Point)
    GiD_Process escape escape escape escape utilities variables \
	CustomRender(Show,Line) $CustomizeRenderPriv(Show,Line)
    GiD_Process escape escape escape escape utilities variables \
	CustomRender(Show,Surface) $CustomizeRenderPriv(Show,Surface)
    GiD_Process escape escape escape escape utilities variables \
	CustomRender(Show,Volume) $CustomizeRenderPriv(Show,Volume)
    GiD_Process escape escape escape escape utilities variables \
	CustomRender(ColorBy,Point) $CustomizeRenderPriv(ColorBy,Point)
    GiD_Process escape escape escape escape utilities variables \
	CustomRender(ColorBy,Line) $CustomizeRenderPriv(ColorBy,Line)
    GiD_Process escape escape escape escape utilities variables \
	CustomRender(ColorBy,Surface) $CustomizeRenderPriv(ColorBy,Surface)
    GiD_Process escape escape escape escape utilities variables \
	CustomRender(ColorBy,Volume) $CustomizeRenderPriv(ColorBy,Volume)
    GiD_Process escape escape escape escape utilities variables \
	CustomRender(Size,Point) $CustomizeRenderPriv(Size,Point)
    GiD_Process escape escape escape escape utilities variables \
	CustomRender(Size,Line) $CustomizeRenderPriv(Size,Line)
    GiD_Process escape escape escape escape utilities variables \
	CustomRender(Size,Surface) $CustomizeRenderPriv(Size,Surface)
    GiD_Process escape escape escape escape CustomRender(Size,Volume) \
	$CustomizeRenderPriv(Size,Volume)
    GiD_Process escape escape escape escape utilities variables \
	CustomRender(FillSurface) $CustomizeRenderPriv(FillSurface) 

    if { [GiD_Info variables CustomRender(Lighting)] != $CustomizeRenderPriv(Lighting) } {
	GiD_Process escape escape escape escape utilities variables \
	    CustomRender(Lighting) $CustomizeRenderPriv(Lighting)
	GiD_Process escape escape escape escape view render \
	    customized changecustom [GiD_Info customrenders current] escape
    }
    GiD_Process escape escape escape escape utilities variables \
	CustomRender(Blend) $CustomizeRenderPriv(Blend)

    GiD_Redraw
    
    ::GidUtils::EnableWarnLine
}
