#   root     is the parent window for this user interface

proc pref_grid_ui {root args} {
    global ChangeVarInfo
    set base $root
   
    frame $base.frame1 -borderwidth 2 -relief ridge
    frame $base.frame2 -borderwidth 2 -relief ridge
    frame $base.frame3 -borderwidth 2 -relief ridge
    frame $base.frame4 -borderwidth 2 -relief ridge
    
    checkbutton $base.frame1.cb1 -disabledforeground grey60 \
	    -text [_ "Show grid lines"] -variable ChangeVarInfo(Grid,Show) -justify left
    GidHelp $base.frame1.cb1 [_ "Show or hide the auxiliary grid lines."]
    checkbutton $base.frame1.cb2 -disabledforeground grey60 \
	    -text [_ "Activate snap"] -variable ChangeVarInfo(Grid,Active) -justify left
    GidHelp $base.frame1.cb2 \
	    [_ "Activate/deactivate snap that restricts cursor movement to the specified intervals."]

    label $base.frame2.l1 -text [_ "X Spacing"]:
    entry $base.frame2.e1 -borderwidth 1 -insertborderwidth 1 \
	    -textvariable ChangeVarInfo(Grid,SpacingX) -width 8
    label $base.frame2.l2 -text [_ "Y Spacing"]:
    entry $base.frame2.e2 -borderwidth 1 -insertborderwidth 1 \
	    -textvariable ChangeVarInfo(Grid,SpacingY) -width 8
    GidHelp $base.frame2 [_ "Distance between grid lines."]
    label $base.frame2.l3 -text [_ "Major line every"]:
    spinbox $base.frame2.sb1 -from 0 -to 100 -increment 1 -width 8 \
	-textvariable ChangeVarInfo(Grid,MajorLineEvery)
   
    label $base.frame3.l1 -text [_ "X Extents"]:
    entry $base.frame3.e1 -borderwidth 1 -insertborderwidth 1 \
	    -textvariable ChangeVarInfo(Grid,ExtentsX) -width 8
    label $base.frame3.l2 -text [_ "Y Extents"]:
    entry $base.frame3.e2 -borderwidth 1 -insertborderwidth 1 \
	    -textvariable ChangeVarInfo(Grid,ExtentsY) -width 8
    GidHelp $base.frame3 [_ "Dimensions of grid to be drawn."]
    
    checkbutton $base.frame4.cb1 -disabledforeground grey60 \
	    -text [_ "Draw axis"] -variable ChangeVarInfo(Grid,DrawAxis) -justify left
    label $base.frame4.l1 -text [_ "X Center"]:
    entry $base.frame4.e1 -borderwidth 1 -insertborderwidth 1 \
	    -textvariable ChangeVarInfo(Grid,CenterX) -width 8
    label $base.frame4.l2 -text [_ "Y Center"]:
    entry $base.frame4.e2 -borderwidth 1 -insertborderwidth 1 \
	    -textvariable ChangeVarInfo(Grid,CenterY) -width 8
    GidHelp $base.frame4 [_ "grid center to be drawn."]
    

    grid $base.frame1 -in $root -sticky nsew -padx 6
    grid $base.frame1.cb1 -sticky w
    grid $base.frame1.cb2 -sticky w
    grid $base.frame2 -in $root.frame1 -sticky nsew -padx 6 
    grid $base.frame3 -in $root.frame1 -sticky nsew -padx 6 
    grid $base.frame4 -in $root.frame1 -sticky nsew -padx 6

    grid $base.frame2.l1 $base.frame2.e1 -sticky w -padx 4 -pady 3
    grid $base.frame2.l2 $base.frame2.e2 -sticky w -padx 4 -pady 3
    grid $base.frame2.l3 $base.frame2.sb1 -sticky w -padx 4 -pady 3
    grid configure $base.frame2.e1 $base.frame2.e2 $base.frame2.sb1 -sticky ew

    grid $base.frame3.l1 $base.frame3.e1 -sticky w -padx 4 -pady 3
    grid $base.frame3.l2 $base.frame3.e2 -sticky w -padx 4 -pady 3
    grid configure $base.frame3.e1 $base.frame3.e2 -sticky ew

    grid $base.frame4.cb1 -sticky w -columnspan 2
    grid $base.frame4.l1 $base.frame4.e1 -sticky w -padx 4 -pady 3
    grid $base.frame4.l2 $base.frame4.e2 -sticky w -padx 4 -pady 3
    grid configure $base.frame4.e1 $base.frame4.e2 -sticky ew    

    grid rowconfigure $root {4} -weight 1 -minsize 2
    grid columnconfigure $root 0 -weight 1 -minsize 170
    
    grid rowconfigure $base.frame1 0 -weight 1 -minsize 2
    grid columnconfigure $base.frame1 0 -weight 1 -minsize 2
    
    grid rowconfigure $base.frame2 0 -weight 1 -minsize 2
    grid columnconfigure $base.frame2 {0 1} -weight 1 -minsize 2
    
    grid rowconfigure $base.frame3 0 -weight 1 -minsize 2
    grid columnconfigure $base.frame3 {0 1} -weight 1 -minsize 2

    grid rowconfigure $base.frame4 0 -weight 1 -minsize 2
    grid columnconfigure $base.frame4 {0 1} -weight 1 -minsize 2
}
